﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;

namespace ComPort2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
       
        private void Form1_Load(object sender, EventArgs e)
        {
            string[] s=SerialPort.GetPortNames();
            for (int i = 0; i < s.Length; i++)
                comboBox1.Items.Add(s[i]);
            if (s.Length > 0)
                comboBox1.SelectedIndex = 0;
        }
        SerialPort serialPort1;
        private void button1_Click(object sender, EventArgs e)
        {
            
            serialPort1=new SerialPort();
            serialPort1.PortName = comboBox1.Text;
            serialPort1.DtrEnable = checkBox4.Checked;
            serialPort1.RtsEnable = checkBox5.Checked;
            serialPort1.BaudRate=1200;
            serialPort1.StopBits= StopBits.One;
            serialPort1.DataBits=8;
            serialPort1.Parity= Parity.None;
            //serialPort1.ReadTimeout = SerialPort.InfiniteTimeout; ;
            //serialPort1.WriteTimeout = SerialPort.InfiniteTimeout; ;
            //serialPort1.PinChanged += new SerialPinChangedEventHandler(pincheng);
            serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialPort1_DataReceived);
            button1.Enabled = false;
          
        }
        void pincheng(object sender, SerialPinChangedEventArgs e)
        {
            //MessageBox.Show(e.EventType.ToString());
        }
        public String log
        {
            get { return ""; }
            set { MessageBox.Show(value); }
        }
        void datashow(object s, EventArgs e)
        {
            textBox1.Text += data;
        }

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            
        }

        string data = "";
        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            textBox1.Text=serialPort1.ReadLine();
            //serialPort1.DiscardInBuffer;
            //serialPort1.DiscardOutBuffer;
            //this.Invoke(new EventHandler(datashow));
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //try
            //{
                serialPort1.Open();
                button2.Enabled = false;
            //}
            //catch (IOException es) { MessageBox.Show(es.Message); }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            serialPort1.Write(textBox2.Text);
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            if (serialPort1 != null)
                if (serialPort1.IsOpen)
                    serialPort1.Close();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (serialPort1 != null)
                if (serialPort1.IsOpen)
                {
                    serialPort1.Close();
                    button1.Enabled = true;
                    button2.Enabled = true;
                }
        }

       
    }
   
}